﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

namespace HeuristicLab.Problems.Instances {
  public class CFSAPData {
    /// <summary>
    /// The name of the instance
    /// </summary>
    public string Name { get; set; }
    /// <summary>
    /// Optional! The description of the instance
    /// </summary>
    public string Description { get; set; }
    /// <summary>
    /// The number of jobs.
    /// </summary>
    public int Jobs { get; set; }
    /// <summary>
    /// The number of machine nests.
    /// </summary>
    public int MachineNests { get; set; }
    /// <summary>
    /// Each row represents the processing times for all the jobs on a certain machine nest
    /// </summary>
    public int[,] ProcessingTimes { get; set; }
    /// <summary>
    /// In the first dimension setup times are per machine,
    /// the second and third dimension represent jobs.
    /// A set-up from the job to itself might also occur,
    /// for instance when a cycle is complete and it is the only job at a certain nest
    /// </summary>
    public int[,,] SetupTimes { get; set; }
  }
}
